#include <QApplication>
#include <QWidget>
#include <QWindow>
#include <QByteArray>
#include <QDebug>
#include <unistd.h>
#include <qpa/qplatformnativeinterface.h>
#include <QPlatformSurfaceEvent>

struct wl_surface;

class MyWindow : public QWidget
{
public:
    MyWindow(QWidget *parent=0)
      : QWidget(parent)
      {}
    bool event(QEvent *e)
    {
        if (e->type() == QEvent::PlatformSurface) {
            if (auto pe = dynamic_cast<QPlatformSurfaceEvent*>(e)) {
                qWarning()<<"QPlatformSurfaceEvent"<<pe;
                QPlatformNativeInterface *native = qApp->platformNativeInterface();
                if (!native) {
                    qWarning()<<"No native interface";
                    return false;
                }
                create();
                wl_surface *s = reinterpret_cast<wl_surface*>(native->nativeResourceForWindow(QByteArrayLiteral("surface"), windowHandle()));
                qWarning()<<"Surface:"<<s;
            }
        }
        return false;
    }
};

int main(int argc, char *argv[])
{
    QApplication app(argc, argv);
    MyWindow window;
    window.setGeometry(0, 0, 100, 200);

    QPlatformNativeInterface *native = QGuiApplication::platformNativeInterface();
    if (native) {
        qDebug() << "Native is there";
    }
    
    //sleep(1);
    qDebug()<<"HH";
    window.show();
    wl_surface *s = reinterpret_cast<wl_surface*>(native->nativeResourceForWindow("surface", window.windowHandle()));
    if (!s) {
        qDebug() << "surface is not there";
    } else {
        qDebug() << "Surface gets created *shrug*";
    }
    return app.exec();
}
